import java.awt.Color;
import java.util.Arrays;
/*ghassan fakher
 * section 6
 gkf01*/
public class CardGame {
	private Card[] p1Hand;
	private Card[] p2Hand;
	private CardDeck cardDeck;
	//constructor
	public CardGame()
	{
		p1Hand = new Card[5];
		p2Hand = new Card[5];
		cardDeck = new CardDeck();
		
	}
	public void shuffle()
	{
		cardDeck.shuffle();
	}
	//string representation of the players' hands
	public String toString()
	{
		return "Player 1 hand: " + Arrays.toString(p1Hand) + "\nPlayer 2 hand: " + Arrays.toString(p2Hand); 
	}
	//distributes the cards between the players
	private void dealCards()
	{
		
		for(int i = 0; i < 5; i++)
		{
			p1Hand[i] = cardDeck.draw();
			p2Hand[i] = cardDeck.draw();
		}
	}
	public int winner()
	{
		int p1Wins = 0;
		int p2Wins = 0;
		for(int i = 0; i < 5; i++)
		{
			if(checkCard(p1Hand[i], p2Hand[i]) == true)
				p1Wins++;
			else
				p2Wins++;
		}
		if(p1Wins > p2Wins)
		{
			return 1;
		}
		else
		{
			return 2;
		}
		
	}
	private boolean checkCard(Card p1Card, Card p2Card)
	{
		return p1Card.stronger(p2Card);
	}
	public void drawGame()
	{
		Draw x = new Draw("game");
		x.setCanvasSize(500, 500);
		x.setXscale(0, 100);
		x.setYscale(0, 100);
		x.clear(Color.green);
		double xpos = 10;
		for(int i = 0; i < 5; i++)
		{
			x.picture(xpos, 15, "cards\\" + cardRep(p1Hand[i]) + ".gif");
			x.picture(xpos, 85, "cards\\" + cardRep(p2Hand[i]) + ".gif");
			xpos += 20;
		}
		x.text(50, 0, "player 1");
		x.text(50, 100, "player 2");
	}
	private String cardRep(Card pCard)
	{	
		if(pCard == null)
				return "b";
		else
		{	
			if(pCard.toString().contains("10"))
				return "t" + pCard.suit().toLowerCase().charAt(0);
			else
				return pCard.toString().toLowerCase(); 
		}
	}
	public void drawGameWithWinner(int player)
	{
		Draw x = new Draw("game");
		x.setCanvasSize(500, 500);
		x.setXscale(0, 100);
		x.setYscale(0, 100);
		x.clear(Color.green);
		double xpos = 10;
		for(int i = 0; i < 5; i++)
		{
			if(p1Hand[i].stronger(p2Hand[i]))
			{
				x.picture(xpos, 15, "cards\\" + cardRep(p1Hand[i]) + ".gif");
				x.picture(xpos, 85, "cards\\b.gif");
			}
			else
			{
				x.picture(xpos, 15, "cards\\b.gif");
				x.picture(xpos, 85, "cards\\"+ cardRep(p2Hand[i])+".gif");
			}
			xpos += 20;
		}
		x.text(50, 0, "player 1");
		x.text(50, 100, "player 2");
		x.text(50, 50, "player " + player + " wins");
	}
	public static void main(String[] args)
	{
		CardGame game = new CardGame();
		game.shuffle();
		game.dealCards();
		game.drawGame();
		int winner = game.winner();
		game.drawGameWithWinner(winner);
	}
}
